Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditHelper.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditHelper.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditHelper.cs	(revision 11730)
@@ -0,0 +1,37 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  class BanditHelper {
+    public static void SampleArms(Random random, IBandit bandit, int nSamples, out double expRewardEst, out int bestArmForExpReward, out int bestArmForMaxReward) {
+      bestArmForExpReward = 0;
+      bestArmForMaxReward = 0;
+      expRewardEst = 0.0;
+      var bestSumReward = 0.0;
+      var bestUpperPercCount = 0;
+      for (int a = 0; a < bandit.NumArms; a++) {
+        var sumReward = 0.0;
+        var upperPercCount = 0;
+
+        for (int i = 0; i < nSamples; i++) {
+          var reward = bandit.Pull(a);
+          sumReward += reward;
+          if (reward >= 0.95) upperPercCount++;
+        }
+
+        if (sumReward > bestSumReward) {
+          bestSumReward = sumReward;
+          bestArmForExpReward = a;
+          expRewardEst = bestSumReward / nSamples;
+        }
+        if (upperPercCount > bestUpperPercCount) {
+          bestUpperPercCount = upperPercCount;
+          bestArmForMaxReward = a;
+        }
+      }
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/BernoulliBandit.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/BernoulliBandit.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/BernoulliBandit.cs	(revision 11730)
@@ -6,7 +6,11 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class BernoulliBandit {
+  public class BernoulliBandit : IBandit {
     public int NumArms { get; private set; }
     public double OptimalExpectedReward { get; private set; } // reward of the best arm, for calculating regret
+    public int OptimalExpectedRewardArm { get; private set; }
+    // the arm with highest expected reward also has the highest probability of return a reward of 1.0
+    public int OptimalMaximalRewardArm { get { return OptimalExpectedRewardArm; } }
+
     private readonly Random random;
     private readonly double[] expReward;
@@ -19,5 +23,8 @@
       for (int i = 0; i < nArms; i++) {
         expReward[i] = random.NextDouble();
-        if (expReward[i] > OptimalExpectedReward) OptimalExpectedReward = expReward[i];
+        if (expReward[i] > OptimalExpectedReward) {
+          OptimalExpectedReward = expReward[i];
+          OptimalExpectedRewardArm = i;
+        }
       }
     }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/IBandit.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/IBandit.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/IBandit.cs	(revision 11730)
@@ -0,0 +1,16 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public interface IBandit {
+    int NumArms { get; }
+    double OptimalExpectedReward { get; } // expected reward of the best arm, for calculating regret
+    int OptimalExpectedRewardArm { get; } // arm which is optimal for optimization of expected reward
+    int OptimalMaximalRewardArm { get; } // arm which is optimal for optimization of maximal reward
+
+    double Pull(int arm); // pulling an arm returns a regret
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/TruncatedNormalBandit.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/TruncatedNormalBandit.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Bandits/TruncatedNormalBandit.cs	(revision 11730)
@@ -4,9 +4,14 @@
 using System.Text;
 using System.Threading.Tasks;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class TruncatedNormalBandit {
+  public class TruncatedNormalBandit : IBandit {
     public int NumArms { get; private set; }
     public double OptimalExpectedReward { get; private set; } // reward of the best arm, for calculating regret
+    public int OptimalExpectedRewardArm { get; private set; }
+    // the arm with highest expected reward also has the highest probability of return a reward of 1.0
+    public int OptimalMaximalRewardArm { get { return OptimalExpectedRewardArm; } }
+
     private readonly Random random;
     private readonly double[] expReward;
@@ -18,6 +23,9 @@
       OptimalExpectedReward = double.NegativeInfinity;
       for (int i = 0; i < nArms; i++) {
-        expReward[i] = random.NextDouble();
-        if (expReward[i] > OptimalExpectedReward) OptimalExpectedReward = expReward[i];
+        expReward[i] = random.NextDouble() * 0.7;
+        if (expReward[i] > OptimalExpectedReward) {
+          OptimalExpectedReward = expReward[i];
+          OptimalExpectedRewardArm = i;
+        }
       }
     }
@@ -28,5 +36,5 @@
       double x = 0;
       do {
-        var z = Transform(random.NextDouble(), random.NextDouble());
+        var z = Rand.RandNormal(random);
         x = z * 0.1 + expReward[arm];
       }
@@ -34,9 +42,4 @@
       return x;
     }
-
-    // box muller transform
-    private double Transform(double u1, double u2) {
-      return Math.Sqrt(-2 * Math.Log(u1)) * Math.Cos(2 * Math.PI * u2);
-    }
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj	(revision 11730)
@@ -40,8 +40,20 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="BanditHelper.cs" />
     <Compile Include="Bandits\BernoulliBandit.cs" />
+    <Compile Include="Bandits\GaussianMixtureBandit.cs" />
+    <Compile Include="Bandits\IBandit.cs" />
     <Compile Include="Bandits\TruncatedNormalBandit.cs" />
+    <Compile Include="Models\BernoulliModel.cs" />
+    <Compile Include="Models\GaussianModel.cs" />
+    <Compile Include="Models\GaussianMixtureModel.cs" />
+    <Compile Include="Models\IModel.cs" />
     <Compile Include="Policies\BanditPolicy.cs" />
     <Compile Include="Policies\BernoulliThompsonSamplingPolicy.cs" />
+    <Compile Include="Policies\BoltzmannExplorationPolicy.cs" />
+    <Compile Include="Policies\ChernoffIntervalEstimationPolicy.cs" />
+    <Compile Include="Policies\GenericThompsonSamplingPolicy.cs" />
+    <Compile Include="Policies\ThresholdAscentPolicy.cs" />
+    <Compile Include="Policies\UCTPolicy.cs" />
     <Compile Include="Policies\GaussianThompsonSamplingPolicy.cs" />
     <Compile Include="Policies\Exp3Policy.cs" />
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IPolicy.cs	(revision 11730)
@@ -20,4 +20,6 @@
     // reset causes the policy to be reinitialized to it's initial state (as after constructor-call)
     void Reset();
+
+    void PrintStats();
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs	(revision 11730)
@@ -0,0 +1,69 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.Bandits.Models {
+  public class BernoulliModel : IModel {
+    private readonly int numActions;
+    private readonly int[] success;
+    private readonly int[] failure;
+
+    // parameters of beta prior distribution
+    private readonly double alpha;
+    private readonly double beta;
+
+    public BernoulliModel(int numActions, double alpha = 1.0, double beta = 1.0) {
+      this.numActions = numActions;
+      this.success = new int[numActions];
+      this.failure = new int[numActions];
+      this.alpha = alpha;
+      this.beta = beta;
+    }
+
+
+    public double[] SampleExpectedRewards(Random random) {
+      // sample bernoulli mean from beta prior
+      var theta = new double[numActions];
+      for (int a = 0; a < numActions; a++) {
+        if (success[a] == -1)
+          theta[a] = 0.0;
+        else {
+          theta[a] = Rand.BetaRand(random, success[a] + alpha, failure[a] + beta);
+        }
+      }
+
+      // no need to sample we know the exact expected value
+      // the expected value of a bernoulli variable is just theta
+      return theta.Select(t => t).ToArray();
+    }
+
+    public void Update(int action, double reward) {
+      const double EPSILON = 1E-6;
+      Debug.Assert(Math.Abs(reward - 0.0) < EPSILON || Math.Abs(reward - 1.0) < EPSILON);
+      if (Math.Abs(reward - 1.0) < EPSILON) {
+        success[action]++;
+      } else {
+        failure[action]++;
+      }
+    }
+
+    public void Disable(int action) {
+      success[action] = -1;
+    }
+
+    public void Reset() {
+      Array.Clear(success, 0, numActions);
+      Array.Clear(failure, 0, numActions);
+    }
+
+    public void PrintStats() {
+      for (int i = 0; i < numActions; i++) {
+        Console.Write("{0:F2} ", success[i] / (double)failure[i]);
+      }
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianMixtureModel.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianMixtureModel.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianMixtureModel.cs	(revision 11730)
@@ -0,0 +1,71 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.Bandits.Models {
+  public class GaussianMixtureModel : IModel {
+    private readonly int numActions;
+    private readonly double[][] meanMean; // mean of mean for each arm and component 
+    private readonly double[][] meanVariance; // variance of mean for each arm and component 
+    private readonly double[][] componentProb;
+
+    // parameters of beta prior distribution
+    private int numComponents;
+    private double priorMean;
+
+    public GaussianMixtureModel(int numActions, double priorMean = 0.5, int nComponents = 5) {
+      this.numActions = numActions;
+      this.numComponents = nComponents;
+      this.priorMean = priorMean;
+      this.meanMean = new double[numActions][];
+      this.meanVariance = new double[numActions][];
+      this.componentProb = new double[numActions][];
+      for (int a = 0; a < numActions; a++) {
+        // TODO: probably need to initizalize this randomly to allow learning
+        meanMean[a] = Enumerable.Repeat(priorMean, nComponents).ToArray();
+        meanVariance[a] = Enumerable.Repeat(1.0, nComponents).ToArray(); // prior variance of mean variance = 1
+        componentProb[a] = Enumerable.Repeat(1.0 / nComponents, nComponents).ToArray(); // uniform prior for component probabilities
+      }
+    }
+
+
+    public double[] SampleExpectedRewards(Random random) {
+      // sample mean foreach action and component from the prior
+      var exp = new double[numActions];
+      for (int a = 0; a < numActions; a++) {
+        var sumReward = 0.0;
+        var numSamples = 10000;
+        var sampledComponents = Enumerable.Range(0, numComponents).SampleProportional(random, componentProb[a]).Take(numSamples);
+        foreach (var k in sampledComponents) {
+          sumReward += Rand.RandNormal(random) * Math.Sqrt(meanVariance[a][k]) + meanMean[a][k];
+        }
+        exp[a] = sumReward / (double)numSamples;
+      }
+
+      return exp;
+    }
+
+    public void Update(int action, double reward) {
+      // see http://www.cs.toronto.edu/~mackay/itprnn/ps/302.320.pdf Algorithm 22.2 soft k-means
+      throw new NotImplementedException();
+    }
+
+    public void Disable(int action) {
+      Array.Clear(meanMean[action], 0, meanMean[action].Length);
+      Array.Clear(meanVariance[action], 0, meanVariance[action].Length);
+    }
+
+    public void Reset() {
+      Array.Clear(meanMean, 0, meanMean.Length);
+      Array.Clear(meanVariance, 0, meanVariance.Length);
+    }
+
+    public void PrintStats() {
+      throw new NotImplementedException();
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs	(revision 11730)
@@ -0,0 +1,76 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.Bandits.Models {
+  // bayesian estimation of a Gaussian with unknown mean and known variance
+  public class GaussianModel : IModel {
+    private readonly int numActions;
+    private readonly int[] tries;
+    private readonly double[] sumRewards;
+
+
+    // parameters of Gaussian prior for mean
+    private readonly double meanPriorMu;
+    private readonly double meanPriorVariance;
+
+    private readonly double rewardVariance = 0.1; // assumed know reward variance
+
+    public GaussianModel(int numActions, double meanPriorMu, double meanPriorVariance) {
+      this.numActions = numActions;
+      this.tries = new int[numActions];
+      this.sumRewards = new double[numActions];
+      this.meanPriorMu = meanPriorMu;
+      this.meanPriorVariance = meanPriorVariance;
+    }
+
+
+    public double[] SampleExpectedRewards(Random random) {
+      // expected values for reward
+      var theta = new double[numActions];
+
+      for (int a = 0; a < numActions; a++) {
+        if (tries[a] == -1) {
+          theta[a] = double.NegativeInfinity; // disabled action
+        } else {
+          // calculate posterior mean and variance (for mean reward)
+
+          // see Murphy 2007: Conjugate Bayesian analysis of the Gaussian distribution (http://www.cs.ubc.ca/~murphyk/Papers/bayesGauss.pdf)
+          var posteriorVariance = 1.0 / (tries[a] / rewardVariance + 1.0 / meanPriorVariance);
+          var posteriorMean = posteriorVariance * (meanPriorMu / meanPriorVariance + sumRewards[a] / rewardVariance);
+
+          // sample a mean from the posterior 
+          theta[a] = Rand.RandNormal(random) * Math.Sqrt(posteriorVariance) + posteriorMean;
+          // theta already represents the expected reward value => nothing else to do
+        }
+      }
+
+      return theta;
+    }
+
+    public void Update(int action, double reward) {
+      sumRewards[action] += reward;
+      tries[action]++;
+    }
+
+    public void Disable(int action) {
+      tries[action] = -1;
+      sumRewards[action] = 0.0;
+    }
+
+    public void Reset() {
+      Array.Clear(tries, 0, numActions);
+      Array.Clear(sumRewards, 0, numActions);
+    }
+
+    public void PrintStats() {
+      for (int i = 0; i < numActions; i++) {
+        Console.Write("{0:F2} ", sumRewards[i] / (double)tries[i]);
+      }
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/IModel.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/IModel.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/IModel.cs	(revision 11730)
@@ -0,0 +1,15 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public interface IModel {
+    double[] SampleExpectedRewards(Random random);
+    void Update(int action, double reward);
+    void Disable(int action);
+    void Reset();
+    void PrintStats();
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BanditPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BanditPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BanditPolicy.cs	(revision 11730)
@@ -28,4 +28,6 @@
       Actions = Enumerable.Range(0, numInitialActions).ToArray();
     }
+
+    public abstract void PrintStats();
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliThompsonSamplingPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliThompsonSamplingPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BernoulliThompsonSamplingPolicy.cs	(revision 11730)
@@ -55,4 +55,19 @@
       Array.Clear(failure, 0, failure.Length);
     }
+
+    public override void PrintStats() {
+      for (int i = 0; i < success.Length; i++) {
+        if (success[i] >= 0) {
+          Console.Write("{0,5:F2}", success[i] / failure[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+
+    public override string ToString() {
+      return "BernoulliThompsonSamplingPolicy";
+    }
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BoltzmannExplorationPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BoltzmannExplorationPolicy.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/BoltzmannExplorationPolicy.cs	(revision 11730)
@@ -0,0 +1,78 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  // also called softmax policy
+  public class BoltzmannExplorationPolicy : BanditPolicy {
+    private readonly Random random;
+    private readonly double eps;
+    private readonly int[] tries;
+    private readonly double[] sumReward;
+    private readonly double beta;
+
+    public BoltzmannExplorationPolicy(Random random, int numActions, double beta)
+      : base(numActions) {
+      if (beta < 0) throw new ArgumentException();
+      this.random = random;
+      this.beta = beta;
+      this.tries = new int[numActions];
+      this.sumReward = new double[numActions];
+    }
+
+    public override int SelectAction() {
+      Debug.Assert(Actions.Any());
+      // select best
+      var maxReward = double.NegativeInfinity;
+      int bestAction = -1;
+      if (Actions.Any(a => tries[a] == 0))
+        return Actions.First(a => tries[a] == 0);
+
+      var ts = Actions.Select(a => Math.Exp(beta * sumReward[a] / tries[a]));
+      var r = random.NextDouble() * ts.Sum();
+
+      var agg = 0.0;
+      foreach (var p in Actions.Zip(ts, Tuple.Create)) {
+        agg += p.Item2;
+        if (agg >= r) return p.Item1;
+      }
+      throw new InvalidProgramException();
+    }
+    public override void UpdateReward(int action, double reward) {
+      Debug.Assert(Actions.Contains(action));
+
+      tries[action]++;
+      sumReward[action] += reward;
+    }
+
+    public override void DisableAction(int action) {
+      base.DisableAction(action);
+      sumReward[action] = 0;
+      tries[action] = -1;
+    }
+
+    public override void Reset() {
+      base.Reset();
+      Array.Clear(tries, 0, tries.Length);
+      Array.Clear(sumReward, 0, sumReward.Length);
+    }
+
+    public override void PrintStats() {
+      for (int i = 0; i < sumReward.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+
+    public override string ToString() {
+      return string.Format("BoltzmannExplorationPolicy({0:F2})", beta);
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ChernoffIntervalEstimationPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ChernoffIntervalEstimationPolicy.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ChernoffIntervalEstimationPolicy.cs	(revision 11730)
@@ -0,0 +1,79 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  /* see: Streeter and Smith: A simple distribution-free approach to the max k-armed bandit problem, Proceedings  of the 12th
+International Conference, CP 2006, Nantes, France, September 25-29, 2006. pp 560-574 */
+
+  public class ChernoffIntervalEstimationPolicy : BanditPolicy {
+    private readonly int[] tries;
+    private readonly double[] sumReward;
+    private int totalTries = 0;
+    private readonly double delta;
+
+    public ChernoffIntervalEstimationPolicy(int numActions, double delta = 0.01)
+      : base(numActions) {
+      this.delta = delta;
+      this.tries = new int[numActions];
+      this.sumReward = new double[numActions];
+    }
+
+    public override int SelectAction() {
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      double k = Actions.Count();
+      Debug.Assert(k > 0);
+      foreach (var a in Actions) {
+        if (tries[a] == 0) return a;
+        // page 5 of "A simple distribution-free appraoch to the max k-armed bandit problem"
+        // var alpha = Math.Log(2 * totalTries * k / delta);
+        double alpha = Math.Log(2) + Math.Log(totalTries) + Math.Log(k) - Math.Log(delta); // total tries is max tries in the original paper
+        double mu = sumReward[a] / tries[a];
+        var q = mu + (alpha + Math.Sqrt(2 * tries[a] * mu * alpha + alpha * alpha)) / tries[a];
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = a;
+        }
+      }
+      return bestAction;
+    }
+    public override void UpdateReward(int action, double reward) {
+      Debug.Assert(Actions.Contains(action));
+      totalTries++;
+      tries[action]++;
+      sumReward[action] += reward;
+    }
+
+    public override void DisableAction(int action) {
+      base.DisableAction(action);
+      totalTries -= tries[action];
+      tries[action] = -1;
+      sumReward[action] = 0;
+    }
+
+    public override void Reset() {
+      base.Reset();
+      totalTries = 0;
+      Array.Clear(tries, 0, tries.Length);
+      Array.Clear(sumReward, 0, sumReward.Length);
+    }
+
+    public override void PrintStats() {
+      for (int i = 0; i < sumReward.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return string.Format("ChernoffIntervalEstimationPolicy({0:F2})", delta);
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EpsGreedyPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EpsGreedyPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EpsGreedyPolicy.cs	(revision 11730)
@@ -27,11 +27,11 @@
       if (random.NextDouble() > eps) {
         // select best
-        var maxReward = double.NegativeInfinity;
+        var bestQ = double.NegativeInfinity;
         int bestAction = -1;
         foreach (var a in Actions) {
           if (tries[a] == 0) return a;
-          var avgReward = sumReward[a] / tries[a];
-          if (maxReward < avgReward) {
-            maxReward = avgReward;
+          var q = sumReward[a] / tries[a];
+          if (bestQ < q) {
+            bestQ = q;
             bestAction = a;
           }
@@ -65,4 +65,17 @@
       Array.Clear(sumReward, 0, sumReward.Length);
     }
+    public override void PrintStats() {
+      for (int i = 0; i < sumReward.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write(" {0,5:F2} {1}", sumReward[i] / tries[i], tries[i]);
+        } else {
+          Console.Write("-", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return string.Format("EpsGreedyPolicy({0:F2})", eps);
+    }
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/Exp3Policy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/Exp3Policy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/Exp3Policy.cs	(revision 11730)
@@ -52,4 +52,17 @@
       foreach (var a in Actions) w[a] = 1.0;
     }
+    public override void PrintStats() {
+      for (int i = 0; i < w.Length; i++) {
+        if (w[i] > 0) {
+          Console.Write("{0,5:F2}", w[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return "Exp3Policy";
+    }
   }
 }
